import { createAction, props } from '@ngrx/store';
import {
  MessageType,
  RetrieveResponse,
  MessageSearchType
} from '@ucap-webmessenger/api-message';

export const retrieveMessage = createAction(
  '[Messenger::Message] RetrieveMessage',
  props<{
    messageType: MessageType;
    pageSize?: number;
    pageCount?: number;
  }>()
);
export const retrieveMessageSuccess = createAction(
  '[Messenger::Message] RetrieveMessage Success',
  props<{ res: RetrieveResponse; messageType: MessageType }>()
);
export const retrieveMessageFailure = createAction(
  '[Messenger::Message] RetrieveMessage Failure',
  props<{ error: any }>()
);

export const searchMessage = createAction(
  '[Messenger::Message] searchMessage',
  props<{
    messageType: MessageType;
    pageSize?: number;
    pageCount?: number;
    searchType?: MessageSearchType;
    searchStr?: string;
  }>()
);
export const searchMessageSuccess = createAction(
  '[Messenger::Message] searchMessage Success',
  props<{ res: RetrieveResponse; messageType: MessageType }>()
);
export const searchMessageFailure = createAction(
  '[Messenger::Message] searchMessage Failure',
  props<{ error: any }>()
);
